/* Copyright 2021 CyberTech Labs Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License. */

#include "twoDModel/blocks/drawInCellBlock.h"

using namespace twoDModel;
using namespace blocks;
using namespace kitBase::robotModel;

void DrawInCellBlock::run()
{
	if (!mRobotModelManager) {
		error("No robot");
	}
	const auto &color = stringProperty("Color");
	const auto &text = boolProperty("Evaluate") ? eval<QString>("PrintText") : stringProperty("PrintText");
	if (!errorsOccured()) {
		mRobotModelManager->model().drawManually(propertyToColor(color), text);
		mConnections << connect(&mRobotModelManager->model(), &kitBase::robotModel::RobotModelInterface::endManual
				, this, &DrawInCellBlock::endManual);
	}
}

void DrawInCellBlock::endManual()
{
	for (auto &&connection : mConnections) {
		disconnect(connection);
	}
	emit done(mNextBlockId);
}
