/* Copyright 2007-2015 QReal Research Group
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License. */

#pragma once

#include <QtCore/QString>
#include <QtCore/QTime>

#include <qrkernel/ids.h>

namespace qReal {
namespace gui {

class Error
{
public:
	enum Severity {
		information
		, warning
		, error
		, critical
	};

	Error(const QString &message, const Severity &severity, qReal::Id  const &position);
	Severity severity() const;
	QString message() const;
	QString timestamp() const;
	qReal::Id  position() const;

private:
	QString mMessage;
	QTime mTimestamp;
	Severity mSeverity;
	qReal::Id  mPosition;
};

}
}
